#!/bin/bash
# copy configmap to conf.d/default directory
file_source="/bitnami/configmap/00_default_overrides.xml"
file_target="/bitnami/clickhouse/etc/conf.d/default/00_default_overrides.xml"
rm $file_target || true
mkdir -p /bitnami/clickhouse/etc/conf.d/default/ && cp $file_source $file_target

# copy extra-configmap to conf.d/ directory
file_source="/bitnami/extra-configmap/01_extra_overrides.xml"
file_target="/bitnami/clickhouse/etc/conf.d/extra-configmap/01_extra_overrides.xml"
rm $file_target || true
mkdir -p /bitnami/clickhouse/etc/conf.d/extra-configmap && cp $file_source $file_target

# copy extra-configmap to users.d/ directory
file_source="/bitnami/users-extra-configmap/01_users_extra_overrides.xml"
file_target="/bitnami/clickhouse/etc/users.d/extra-configmap/01_users_extra_overrides.xml"
rm $file_target || true
mkdir -p /bitnami/clickhouse/etc/users.d/users-extra-configmap && cp $file_source $file_target

# Execute entrypoint as usual after obtaining KEEPER_SERVER_ID
# check KEEPER_SERVER_ID in persistent volume via myid
# if not present, set based on POD hostname
if [[ -f "/bitnami/clickhouse/keeper/data/myid" ]]; then
    export KEEPER_SERVER_ID="$(cat /bitnami/clickhouse/keeper/data/myid)"
else
    HOSTNAME="$(hostname -s)"
    if [[ $HOSTNAME =~ (.*)-([0-9]+)$ ]]; then
        export KEEPER_SERVER_ID=${BASH_REMATCH[2]}
    else
        echo "Failed to get index from hostname $HOST"
        exit 1
    fi
fi
exec /opt/bitnami/scripts/clickhouse/entrypoint.sh /opt/bitnami/scripts/clickhouse/run.sh -- --listen_host=0.0.0.0
